
#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     Green
#property indicator_color2     Red
#property indicator_width1     2
#property indicator_width2     2
#property indicator_level1     0
#property indicator_levelstyle STYLE_DOT
#property indicator_levelcolor Gold

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double trend[];
string indicatorFileName;
bool   returnBars;

//
//
//
//
//

int init()
  {
   IndicatorBuffers(6);   
   SetIndexBuffer(0,Buffer1);SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Buffer2);SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Buffer3);
   SetIndexBuffer(3,Buffer4);
   SetIndexBuffer(4,Buffer5);
   SetIndexBuffer(5,trend);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" AC");
return(0);
}
int deinit() { return(0); }

//
//
//+------------------------------------------------------------------+
//| AC Oscillator                                                    |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1); 
         if (returnBars) { Buffer1[0] = limit+1; return(0); }
         if (TimeFrame != Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);         
                  Buffer1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,0,y);
                  Buffer2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,1,y); 
            }      
    return(0);
    }
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) Buffer3[i] = iMA(NULL,0,5,0,MODE_SMA,PRICE_MEDIAN,i)-iMA(NULL,0,34,0,MODE_SMA,PRICE_MEDIAN,i);
   for(i=limit; i>=0; i--) Buffer4[i] = iMAOnArray(Buffer3,0,5,0,MODE_SMA,i);
   for(i=limit; i>=0; i--)
   {
      Buffer5[i] = Buffer3[i]-Buffer4[i]; 
      Buffer1[i] = EMPTY_VALUE;
      Buffer2[i] = EMPTY_VALUE;
      trend[i] = trend[i+1];
   
       if (Buffer5[i] > Buffer5[i+1]) trend[i] = 1;
       if (Buffer5[i] < Buffer5[i+1]) trend[i] =-1;
       if (trend[i] == 1) Buffer1[i] = Buffer5[i];
       if (trend[i] ==-1) Buffer2[i] = Buffer5[i];
    }
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}